'+--------------------------------------------------------------------------+
'|                                                                          |
'|                              zHelpAPI 1.00                               |
'|                                                                          |
'|     Win32 SDK API documentation based on Jos Roca API transcription     |
'|                        and Jos Roca WebBrowser                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                                                                          |
'|                         copyright(c) 2009-2009                           |
'|                                                                          |
'|                Patrice Terrier http://www.zapsolution.com                |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 04-27-2009 (MM-DD-YYYY)            |
'|                        Last revised : 04-27-2009 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "zHelpAPI.exe"
#INCLUDE ONCE "OLECON.INC"                      ' // Ole Container
#INCLUDE ONCE "EXDISP.INC"                      ' // WebBrowser Control

#RESOURCE "zHelpAPI.pbr"

$USECLASS      = "zHelpAPI 1.01"

%MIN_WIDTH     = 640  '// default client width size
%MIN_HEIGHT    = 480  '// default client height size

%ID_COMBOBOX   = 101
%ID_LISTBOX    = 102
%ID_IEWB       = 103
%ID_BTN_UPDATE = 104

$Anti                = "\"
$zLim                = "|"
$RegistryKey         = "SOFTWARE\zHelpAPI"
$RegistryCoordinates = "Coordinates"
%dwStyle             = %WS_EX_CONTROLPARENT
%dwExStyle           = %WS_OVERLAPPEDWINDOW OR %WS_CLIPCHILDREN      

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG
DECLARE FUNCTION MyURLDownloadToFile LIB "urlmon.dll" ALIAS "URLDownloadToFileA" (BYVAL pCaller AS LONG, _
        szURL AS ASCIIZ, szFileName AS ASCIIZ, BYVAL dwReserved AS LONG, BYVAL lpfnCB AS LONG) AS LONG

'// Full file detection.
'FUNCTION zExist (zFileSpec AS ASCIIZ) AS LONG
'    LOCAL fd AS WIN32_FIND_DATA, hFind AS LONG
'    IF LEN(zFileSpec) THEN
'       hFind = FindFirstFile(zFileSpec, fd)
'       IF hFind <> -1 THEN
'          CALL FindClose(hFind&)
'          FUNCTION = -1
'       END IF
'    END IF
'END FUNCTION

'// Returns current Disk and Path
SUB zDskPath(sDsk$, sPath$)
'   Dsk$ and Path$ are ready to be concatened with a filename
'   Dsk$ and Paths correspond to the current directory
    LOCAL zTmp AS ASCIIZ * 260
    IF GetCurrentDirectory(BYVAL SIZEOF(zTmp), zTmp) THEN
       sDsk$ = LEFT$(zTmp, 2)
       sPath$ = RTRIM$(MID$(zTmp, 3), ANY CHR$(0,92)) + $Anti
    END IF
END SUB

'// Splits a full path name, and return the current disk and directory
SUB zSplitN (BYVAL sFullName$, sPathName$, sFilName$)
'   If no path is specified then the current directory is being used.
    sPathName$ = "": sFilName$ = ""
    Length& = LEN(sFullName$)
    IF Length& THEN
       CALL zDskPath(Dsk$, ThisPath$): sFilName$ = sFullName$
       So& = INSTR(-1, sFullName$, $Anti)
       IF So& THEN
          sPathName$ = LEFT$(sFullName$, So&)
       ELSE
          So& = INSTR(sFullName$, ":")
       END IF
       IF sPathName$ = Dsk$ OR LEN(sPathName$) = 0 THEN
          sPathName$ = Dsk$ + ThisPath$
       END IF
       IF So& THEN sFilName$ = MID$(sFullName$, So& + 1, Length& - So&)
    END IF
END SUB

'// Kill directly a file without sending it to recycle.bin
FUNCTION zKillFile (zFullName AS ASCIIZ) AS LONG
    LOCAL zTmp AS ASCIIZ * %MAX_PATH, sPathName, sToKill AS STRING
    CALL zSplitN (zFullName$, sPathName, sToKill)
    sToKill = DIR$(zFullName, 39) ' %NORMAL + %READONLY + %HIDDEN + %SYSTEM + %ARCHIVE
    DO WHILE LEN(sToKill)
       zTmp = sPathName + sToKill
       CALL SetFileAttributes(zTmp, %FILE_ATTRIBUTE_NORMAL)
       IF DeleteFile(zTmp) = 0 THEN FUNCTION = GetLastError: EXIT DO
       sToKill = DIR$
    LOOP
END FUNCTION

'// Get the temp folder
FUNCTION zGetTempPath ALIAS "zGetTempPath" () AS STRING
  ' If the returned GetTempPath directory does not exist the function creates it.
    TempPath$ = SPACE$(GetTempPath(0, BYVAL %NULL))
    Size& = GetTempPath(LEN(TempPath$), BYVAL STRPTR(TempPath$))
    TempPath$ = RTRIM$(TempPath$, ANY CHR$(0,92))
    TempPath$ = TempPath$ + $Anti
    FUNCTION = TempPath$
END FUNCTION

'// Changes the character being used as delimiter to read in a sequential text file.
FUNCTION zSetBufinChar (BYVAL Char$) STATIC AS STRING
    IF LEN(Char$) THEN UserChar$ = Char$
    IF LEN(UserChar$) THEN
       FUNCTION = UserChar$
    ELSE
       FUNCTION = CHR$(13)
    END IF
END FUNCTION

'// Generic open file function
'// Using the low level I/O API produces smaller and faster code than using the PB encapsulation.
FUNCTION zFOpen (zFilName AS ASCIIZ, BYVAL AccessMode AS LONG, BYVAL ShareMode AS LONG, hFile AS LONG) AS LONG

    LOCAl AccessIs, ShareIs, FlagAndAttribute AS LONG

    AccessMode = MIN(MAX(AccessMode, 0), 2)  ' Coherce between 0-2
    IF AccessMode = 0 THEN                   ' 0 Open for read only.
       AccessIs = %GENERIC_READ
    ELSEIF AccessMode = 1 THEN               ' 1 Open for write only.
       AccessIs = %GENERIC_WRITE
    ELSE                                     ' 2 Open for read and write.
       AccessIs = %GENERIC_READ OR %GENERIC_WRITE
    END IF

    ShareMode = MIN(MAX(ShareMode, 1), 4)    ' Coherce between 1-4
    IF ShareMode = 1 THEN                    ' 1 Deny read/write access.
       ShareIs = 0
    ELSEIF ShareMode = 2 THEN                ' 2 Deny write access.
       ShareIs =  %FILE_SHARE_READ
    ELSEIF ShareMode = 3 THEN                ' 3 Deny read access.
       ShareIs =  %FILE_SHARE_WRITE
    ELSE                                     ' 4 Deny none (full share mode).
       ShareIs =  %FILE_SHARE_READ OR %FILE_SHARE_WRITE
    END IF

    IF hFile = -1 THEN
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL OR %FILE_FLAG_WRITE_THROUGH
    ELSE
       FlagAndAttribute = %FILE_ATTRIBUTE_NORMAL
    END IF

    hFile = CreateFile(zFilName, AccessIs, ShareIs, BYVAL %NULL, %OPEN_ALWAYS, FlagAndAttribute, BYVAL %NULL)

    IF hFile = CLNG(%INVALID_HANDLE_VALUE) THEN    ' -1 Fail to create the file
       FUNCTION = GetLastError               ' Set the error code
       hFile = 0                             ' Reset handle number
    END IF

END FUNCTION

'// Dito LOF
FUNCTION zFlof (BYVAL hFile AS LONG) AS LONG
    IF GetFileType(hFile) = %FILE_TYPE_DISK THEN
       LOCAL fSize AS LONG
       fSize = GetFileSize(hFile, BYVAL %NULL)
       IF fSize > -1 THEN FUNCTION = fSize
    END IF
END FUNCTION

'// Dito SEEK
FUNCTION zFSeek (BYVAL hFile AS LONG, BYVAL PosByte AS LONG) AS LONG
    IF SetFilePointer(hFile, PosByte, BYVAL %NULL, %FILE_BEGIN) < 0 THEN
       FUNCTION = GetLastError
    END IF
END FUNCTION

'// Dito GET
FUNCTION zFGet (BYVAL hFile AS LONG, StringBuf AS STRING) AS LONG
    IF hFile THEN
       LOCAL LenBuf, ByttesReaded AS LONG
       LenBuf = LEN(StringBuf)
       IF LenBuf THEN
          IF ReadFile(hFile, BYVAL STRPTR(StringBuf), LenBuf, ByttesReaded, BYVAL %NULL) = 0 THEN
             FUNCTION = GetLastError
          END IF
       END IF
    END IF
END FUNCTION

'// GET at a specific offset
FUNCTION zFGetAt (BYVAL hFile AS LONG, BYVAL nPosByte AS LONG, Buf$) AS LONG
    LOCAL nErrCode AS LONG
    nErrCode = zFSeek(hFile, nPosByte)
    IF nErrCode = 0 THEN nErrCode = zFGet(hFile, Buf$)
    FUNCTION = nErrCode
END FUNCTION

'// Dito CLOSE
SUB zFClose (hFile AS LONG)
    IF hFile THEN CALL CloseHandle(hFile)
    hFile = 0
END SUB

'// Enhanced sequential LINEINPUT
FUNCTION zBufin (zFileName AS ASCIIZ, nDone AS LONG) STATIC AS STRING
DIM sCr AS STRING, sBuffer AS STRING
DIM hFile AS LONG, nLocation AS LONG, nBufSize AS LONG, nBufPos AS LONG, nErrCode AS LONG, nRemaining AS LONG
DIM nCr AS LONG, nSlop AS LONG, nReading AS LONG, nLenCr AS LONG, nSizeFile AS LONG, nSaveCr AS LONG
IF LEN(zFileName) THEN
   IF NOT nReading THEN
      sCr = zSetBufinChar("")          ' added for spec char
      nReading = -1: nDone = 0
      IF ASC(sCr) = 13 THEN             ' added for spec char
         nLenCr = 0: sCr = CHR$(13)
      ELSE                              ' added for spec char
         nLenCr = LEN(sCr)              ' added for spec char
      END IF                            ' added for spec char
      nCr = 0: nLocation = 0
      IF NOT ISFILE(zFileName) THEN GOTO BufEnd  ' Nothing to do
      nErrCode = zFOpen(zFileName, 0, 2, hFile)
      IF nErrCode THEN
         nDone = nErrCode: nReading = 0
         EXIT FUNCTION
      END IF
      nRemaining = zFlof(hFile)                  ' Bytes count to be read
      nSizeFile = nRemaining                     ' Remember this
      IF nRemaining = 0 GOTO BufEnd              ' Nothing to read
      nBufSize = 16384
      sBuffer = SPACE$(nBufSize)
   END IF
   DO WHILE nRemaining                           ' While more in the file
      IF nCr = 0 THEN                            ' If no return was found
         IF nRemaining < nBufSize THEN           ' read only what remains.
            nBufSize = nRemaining                ' Resize the buffer.
            IF nBufSize < 1 THEN EXIT DO         ' Possible only if EOF 26.
            sBuffer = SPACE$(nBufSize)
         END IF
         nErrCode = zFGetAt(hFile, nLocation, sBuffer) ' Read a bloc.
         nLocation = nLocation + nBufSize        ' Here we are.
         nBufPos = 1                             ' Start at the beginning
      END IF                                     ' of that bloc.
      DO                                         ' Walk through buffer.
         nCr = INSTR(nBufPos, sBuffer, sCr)      ' Look for a Return.
         IF nLenCr = 0 THEN                      ' Do this to read files with
            nLenCr = 1                           ' or without LF after CR.
            IF ASC(sBuffer, nCr + 1) = 10 THEN nLenCr = 2
         END IF
         IF nCr THEN                             ' We found one.
            nSaveCr = nCr                        ' Save where
            FUNCTION = MID$(sBuffer, nBufPos, nCr - nBufPos)
            nBufPos = nCr + nLenCr               ' In case of LF skip it
            EXIT FUNCTION                        ' all done for now.
         ELSE                                    ' Back up in the file.
          ' If we reached the end of file and no nCr
          ' was found, return what remains in the string.
            IF nLocation >= nSizeFile THEN
             ' Assign function and trap ^Z
               FUNCTION = RTRIM$(MID$(sBuffer, nSaveCr + nLenCr), CHR$(26))
               nRemaining = nBufSize
               EXIT DO
            END IF
          ' 05-06-1998 () were missing on each side of (nLenCr - 1)
            nSlop = nBufSize - nSaveCr - (nLenCr - 1) ' Calc buffer excess.
            nRemaining = nRemaining + nSlop           ' Calc file excess.
            nLocation = nLocation - nSlop
         END IF
      LOOP WHILE nCr                                 ' While more in buffer.
      nRemaining = nRemaining - nBufSize
      nSaveCr = 0
   LOOP
END IF

BufEnd:
    nReading = 0: nDone = -1: CALL zFClose(hFile)
END FUNCTION

'// To get any file from the Internet
FUNCTION zDownloadFile(zURL AS ASCIIZ, zLocalFilename AS ASCIIZ) AS LONG
    LOCAL nRet AS LONG
    IF MyURLDownloadToFile(0, zURL, zLocalFilename, 0, 0) =  0 THEN nRet = -1
    FUNCTION = nRet
END FUNCTION

'// Create default font.
FUNCTION zDefaultFont () AS LONG
    STATIC hDefault AS LONG
    IF hDefault = 0 THEN hDefault = GetStockObject(%ANSI_VAR_FONT)
    FUNCTION = hDefault
END FUNCTION

'// Set the font being used for a specific control.
SUB zSetCTLFont (BYVAL hCtrl AS LONG, BYVAL hFont AS LONG)
    CALL SendMessage(hCtrl, %WM_SETFONT, hFont, 0)
END SUB

'// Retrieves a listbox specific line of text.
FUNCTION zGetTextCombo(BYVAL hCombo AS LONG, BYVAL nItem AS LONG) AS STRING
   LOCAL nLength AS LONG, sData AS STRING
    nLength = SendMessage(hCombo, %CB_GETLBTEXTLEN, nItem, 0)
    sData = SPACE$(nLength)
    nLength = SendMessage(hCombo, %CB_GETLBTEXT, nItem, BYVAL STRPTR(sData))
    FUNCTION = sData
END FUNCTION

'// Retrieves a listbox specific line of text.
FUNCTION zGetTextListbox(BYVAL hListBox AS LONG, BYVAL nItem AS LONG) AS STRING
   LOCAL nLength AS LONG, sData AS STRING
    nLength = SendMessage(hListBox, %LB_GETTEXTLEN, nItem, 0)
    sData = SPACE$(nLength)
    nLength = SendMessage(hListBox, %LB_GETTEXT, nItem, BYVAL STRPTR(sData))
    FUNCTION = sData
END FUNCTION

'// Returns a registry string
FUNCTION zGetReg (BYVAL hLocation AS DWORD, zSubKeys AS ASCIIZ, zValueName AS ASCIIZ) AS STRING
    LOCAL hKey AS DWORD, zRegVal AS ASCIIZ * %MAX_PATH, dwType AS DWORD, dwSize AS DWORD
    IF hLocation = 0 THEN hLocation = %HKEY_CURRENT_USER
    IF (RegOpenKeyEx(hLocation, TRIM$(zSubKeys, $Anti), 0, %KEY_READ, hKey) = 0) THEN
       dwType = %REG_SZ
     ' Set length of buffer...
       dwSize = SIZEOF(zRegVal)
       CALL RegQueryValueEx(hKey, zValueName, 0, dwType, zRegVal, dwSize)
       CALL RegCloseKey(hKey)
    END IF
    FUNCTION = zRegVal
END FUNCTION

'// Saves a string value to the registry, returns nonzero if successful
FUNCTION zSetReg (BYVAL hLocation AS DWORD, zSubKeys AS ASCIIZ, zRegName AS ASCIIZ, zRegVal AS ASCIIZ) AS LONG
    LOCAL hKey AS DWORD, dwType AS DWORD, dwSize AS DWORD, nRet AS LONG
    nRet = 0
    IF hLocation = 0 THEN hLocation = %HKEY_CURRENT_USER
    IF RegCreateKeyEx(hLocation, TRIM$(zSubKeys, $Anti), 0, "", 0, %KEY_WRITE, BYVAL %Null, hKey, BYVAL %Null) = 0 THEN
     ' Set length of data...
       dwSize = LEN(zRegVal)
       dwType = %REG_SZ
       IF RegSetValueEx(hKey, zRegName, 0, dwType, zRegVal, dwSize) = 0 THEN nRet = %True
       CALL RegCloseKey(hKey)
    END IF
    FUNCTION = nRet
END FUNCTION

SUB zLoadSaveCoordinates (BYREF x AS LONG, BYREF y AS LONG, BYREF w AS LONG, BYREF h AS LONG, BYVAL RW AS LONG) 
    STATIC WasCoordinates AS STRING
    IF RW THEN
       WasCoordinates = LTRIM$(STR$(x)) + "," + LTRIM$(STR$(y)) + "," + LTRIM$(STR$(w)) + "," + LTRIM$(STR$(h))
       IF LEN(WasCoordinates) THEN CALL zSetReg(%HKEY_LOCAL_MACHINE, $RegistryKey, $RegistryCoordinates, (WasCoordinates))
    ELSE
       IF LEN(WasCoordinates) = 0 THEN
          WasCoordinates = zGetReg(%HKEY_LOCAL_MACHINE, $RegistryKey, $RegistryCoordinates)
          x = VAL(PARSE$(WasCoordinates, 1)) 
          y = VAL(PARSE$(WasCoordinates, 2))
          w = VAL(PARSE$(WasCoordinates, 3))
          h = VAL(PARSE$(WasCoordinates, 4))
       END IF
       IF w = 0 OR h = 0 THEN
          w = %MIN_WIDTH: h = %MIN_HEIGHT
          LOCAL rc AS RECT
          CALL SystemParametersInfo(%SPI_GETWORKAREA, 0, BYVAL VARPTR(rc), 0)
          x = ((rc.nRight - rc.nLeft) - w) \ 2
          y = ((rc.nBottom - rc.nTop) - h) \ 2
       END IF 
    END IF
END SUB

FUNCTIOn zLoadIndex(BYVAL hWnd AS LONG) AS LONG

    LOCAL sLocalFile, sUrlPathToUse, sAPI, sLink, sCfg AS STRING
    LOCAL Done AS LONG

    sUrlPathToUse = "http://www.jose.it-berater.org/gdi/"
    sLocalFile = zGetTempPath + "zHelpIndex.htm"
    IF NOT ISFILE((sLocalFile)) THEN
       Done = zDownloadFile(sUrlPathToUse + "iframe/tree.htm", (sLocalFile))
    ELSE
       Done = -1
    END IF
    IF Done THEN
       CALL zSetBufinChar(CHR$(10))
       Done = 0
		 CALL SendMessage(GetDlgItem(hWnd, %ID_COMBOBOX), %LB_RESETCONTENT, 0, 0)
		 CALL SendMessage(GetDlgItem(hWnd, %ID_LISTBOX), %LB_RESETCONTENT, 0, 0)	 
       DO WHILE Done = 0
          sCfg = RTRIM$(LTRIM$(zBufin((sLocalFile), Done)), ");")
          IF INSTR(LCASE$(sCfg), "tree.add(") = 0 THEN
             sCfg = ""
          ELSE
             sCfg = MID$(sCfg, 10)
             IF PARSE$(sCfg, 2) < "1100" THEN sCfg = ""
          END IF
          IF LEN(sCfg) THEN
             sAPI = TRIM$(PARSE$(sCFg, 3), "'")
             sLink = TRIM$(PARSE$(sCfg, 4), "'")
             Replace "../" WITH sUrlPathToUse IN sLink
             IF LEN(sLink) THEN
                CALL SendMessage(GetDlgItem(hWnd, %ID_COMBOBOX), %CB_ADDSTRING, 0, STRPTR(sAPI))
                CALL SendMessage(GetDlgItem(hWnd, %ID_LISTBOX), %LB_ADDSTRING, 0, STRPTR(sLink))
'//             zTrace((sAPI + ", " + sLink))
             END IF
          END IF
       LOOP
    END IF

    FUNCTION = Done
END FUNCTION

'// Main
FUNCTION WINMAIN (BYVAL hInstance AS DWORD, BYVAL hPrevInstance AS DWORD, BYVAL lpszCmdLine AS ASCIIZ PTR, BYVAL nCmdShow AS LONG) AS LONG

    LOCAL wMsg                AS tagMsg
    LOCAL hWnd, IsInitialized AS LONG
    LOCAL wc                  AS WNDCLASSEX
    LOCAL szClassName         AS ASCIIZ * 80
    LOCAL rc                  AS RECT
    LOCAL dwStyle, dwStyleEx  AS DWORD

    ' Initilize the COM library using OleInitialize to allow cut and paste
    CALL OleInitialize(0)
    ' Required: Initialize the Ole Container
    CALL OC_WinInit()


    szClassName = $USECLASS

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(hInstance, szClassName, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = 0 '// %EXTEND_EXTRA * 4
       wc.hInstance     = hInstance
       wc.hIcon         = 0
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = GetSysColorBrush(%COLOR_BTNFACE)
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(szClassName)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF

    IF IsInitialized THEN
       LOCAL UseX, UseY, UseW, UseH AS LONG
       CALL zLoadSaveCoordinates (UseX, UseY, UseW, UseH, 0)

       CALL SetRect(rc, 0, 0, UseW, UseH)
       CALL AdjustWindowRectEx(rc, %dwStyle, %FALSE, %dwExStyle)  ' Adjust Window To True Requested Size

       hWnd = CreateWindowEx(%dwStyle, szClassName, szClassName, %dwExStyle, _
                             UseX, UseY, rc.nRight - rc.nLeft, rc.nBottom - rc.nTop, _  
                             0, 0, hInstance, BYVAL %NULL)

       IF hWnd THEN

			 IF zLoadIndex(hWnd) THEN

            ' Show the window
            CALL ShowWindow(hWnd, nCmdShow)
            CALL UpdateWindow(hWnd)

            ' Message handler loop
            WHILE GetMessage(wMsg, %NULL, 0, 0)
               IF OC_ForwardMessage(GetFocus, wMsg) = 0 THEN
                  IF IsDialogMessage(hWnd, wMsg) = 0 THEN
                     CALL TranslateMessage(wMsg)
                     CALL DispatchMessage(wMsg)
                  END IF
               END IF
            WEND

          ELSE
             MSGBOX "Download failed!" ,, $USECLASS
          END IF

       END IF

    END IF

    ' Uninitialize the COM library
    CALL OleUninitialize()

    FUNCTION = wMsg.wParam

END FUNCTION

'// Main window procedure
FUNCTION WndProc (BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) AS LONG

    LOCAL nItem, hCtrl  AS LONG
    LOCAL rc, rw        AS RECT
    LOCAL vUrl          AS VARIANT
    LOCAL sUseThisURL   AS STRING
    LOCAL pIWebBrowser2 AS IWebBrowser2

    SELECT CASE LONG Msg

    CASE %WM_CREATE
         ' Get the coordinates of the main window client area
         CALL GetClientRect(hWnd, rc)

         hCtrl = CreateWindowEx(%WS_EX_CLIENTEDGE, "COMBOBOX", "", %WS_CHILD OR %WS_BORDER OR %WS_VISIBLE OR %WS_VSCROLL OR %CBS_DROPDOWN OR %WS_TABSTOP OR %CBS_HASSTRINGS OR %ES_LEFT OR %CBS_AUTOHSCROLL OR %CBS_SIMPLE, _
                                1, 1, 200, 105, hWnd, %ID_COMBOBOX, GetModuleHandle(""), BYVAL %NULL)
         CALL zSetCTLFont(hCtrl, zDefaultFont())

         hCtrl = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_HASSTRINGS, 0, 0, 0, 0, hWnd, %ID_LISTBOX, GetModuleHandle(""), BYVAL %NULL)

         hCtrl = CreateWindowEx(0, "BUTTON", "Update", %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, _
                           202, 0, 50, 23, hWnd, %ID_BTN_UPDATE, GetModuleHandle(""), BYVAL %NULL)
         CALL zSetCTLFont(hCtrl, zDefaultFont())

         hCtrl = CreateWindowEx(0, $OC_CLASSNAME, "Shell.Explorer", %WS_CHILD OR %WS_VISIBLE OR %WS_TABSTOP, _
                0, 0, 0, 0, hWnd, %ID_IEWB, GetModuleHandle(""), BYVAL %NULL)
         CALL SetFocus(hCtrl)

         ' Create an instance of the WebBrowser Control using Jos OLECON container
         ' Set the focus in the WebBrowser Control
         ' Get a pointer to the IWebBrowser2 interface
         pIWebBrowser2 = OC_GetDispatch(GetDlgItem(hWnd, %ID_IEWB))
         IF ISOBJECT(pIWebBrowser2) THEN
            ' Navigate to a site
            vUrl = "http://www.zapsolution.com/pictures/zHelpAPI.jpg"
            pIWebBrowser2.Navigate2(vUrl)
            ' Release the interface
            pIWebBrowser2 = NOTHING
         END IF

    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         CALL SetRect(rc, 0, 0, %MIN_WIDTH, %MIN_HEIGHT)
         CALL AdjustWindowRectEx(rc, %dwStyle, %FALSE, %dwExStyle)  ' Adjust Window To True Requested Size
         pMM = lParam
         @pMM.ptMinTrackSize.x = rc.nRight
         @pMM.ptMinTrackSize.y = rc.nBottom

    CASE %WM_SIZE
         ' Resizes the control
         IF wParam <> %SIZE_MINIMIZED THEN
            CALL GetClientRect(hWnd, rc)
            CALL MoveWindow(GetDlgItem(hWnd, %ID_IEWB), 0, 23, rc.nRight - rc.nLeft, rc.nBottom - rc.nTop - 23, %TRUE)
         END IF

    CASE %WM_COMMAND
         SELECT CASE LONG LO(WORD, wParam)

         CASE %IDCANCEL
              IF HI(WORD, wParam) = %BN_CLICKED THEN CALL SendMessage(hWnd, %WM_CLOSE, 0, 0): EXIT FUNCTION
         
         CASE %ID_COMBOBOX
              IF HI(WoRD, wParam) = %CBN_SELCHANGE THEN
                 nItem = SendMessage(GetDlgItem(hWnd, %ID_COMBOBOX), %CB_GETCURSEL, 0, 0)
'//              CALL zTrace(zGetTextCombo(GetDlgItem(hWnd, %ID_COMBOBOX), nItem))
                 sUseThisURL = zGetTextListBox(GetDlgItem(hWnd, %ID_LISTBOX), nItem)
'//              CALL zTrace((sUseThisURL))

                 ' Get a pointer to the IWebBrowser2 interface
                 pIWebBrowser2 = OC_GetDispatch(GetDlgItem(hWnd, %ID_IEWB))
                 IF ISOBJECT(pIWebBrowser2) THEN
                    vURL = sUseThisURL
                    ' Navigate to a site
                    pIWebBrowser2.Navigate2(vURL)
                    ' Release the interface
                    pIWebBrowser2 = NOTHING
                 END IF
             END IF

         CASE %ID_BTN_UPDATE
              CALL zKillFile(zGetTempPath + "zHelpIndex.htm")
              IF zLoadIndex(hWnd) THEN
                 MSGBOX "Index has been updated successfuly!" ,, $USECLASS
              ELSE
                 MSGBOX "Download failed!" ,, $USECLASS
              END IF
				  
         END SELECT

    CASE %WM_SYSCOMMAND
         ' Capture this message and send a WM_CLOSE message
         IF (wParam AND &HFFF0) = %SC_CLOSE THEN
            SendMessage hWnd, %WM_CLOSE, 0, 0
            EXIT FUNCTION
         END IF

    CASE %WM_DESTROY
         CALL GetWindowRect(hWnd, rw)
         CALL GetClientRect(hWnd, rc)
         CALL zLoadSaveCoordinates(rw.nLeft, rw.nTop, rc.nRight, rc.nBottom, 1)
         CALL PostQuitMessage(0)
         EXIT FUNCTION

    END SELECT

    FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION
